TITLE TUC OpenVPN Version 1.9.1
REM   Copyright 2020 Clausthal University of Technology
REM   Version: 1.9.1 05.08.2021
cls
@echo off
REM Abfrage ob die Batch Datei als Admin ausgefhrt wird
mkdir "%windir%\system32\test" 2>nul
if "%errorlevel%" == "0" (rmdir "%windir%\system32\test") else (goto :keinadmin)

REM Aktuelles Verzeichnis in Variable schreiben
set verz=%~dp0

cls
echo VPN wird installiert.

REM   evtl. vorhandenes OpenVPN stoppen
start /wait taskkill /IM openvpn-gui.exe
start /wait net stop OpenVPNServiceInteractive
start /wait taskkill /IM openvpnserv.exe
REM   alte Firewall Regeln lschen
netsh advfirewall firewall delete rule name="TUC OpenVPN UDP" > nul
netsh advfirewall firewall delete rule name="TUC OpenVPN TCP" > nul
REM   Zertifikat installieren
start /wait certutil.exe -addstore -enterprise -f "TrustedPublisher" "%verz%config\openvpn.cer" > nul

REM Abfrage ob es Windows 10 ist
for /f "tokens=4-5 delims=. " %%i in ('ver') do set VERSION=%%i.%%j
if "%version%" == "10.0" (goto :win10) else (goto :win7bis8)

:win10
REM Installation in exe umbenennen
ren "%verz%openvpn-install-2.4.11-I602-Win10.tuc" ""openvpn-install-2.4.11-I602-Win10.exe"
REM   OpenVPN Client installieren
start /wait "OpenVPN Installation" "%verz%openvpn-install-2.4.11-I602-Win10.exe" /S
goto beide


:win7bis8
REM Installation in exe umbenennen
ren "%verz%openvpn-install-2.4.11-I602-Win7.tuc" ""openvpn-install-2.4.11-I602-Win7.exe"
REM   OpenVPN Client installieren
start /wait "OpenVPN Installation" "%verz%openvpn-install-2.4.11-I602-Win7.exe" /S
goto beide

:beide
del "%verz%config\openvpn.cer"
REM   TUC Profil kopieren
xcopy  /Y "%verz%config\*" "%ProgramFiles%\OpenVPN\config"
REM   Windows Firewall automatisch konfigurieren
netsh advfirewall firewall add rule name="TUC OpenVPN UDP" dir=in action=allow program="%ProgramFiles%\openvpn\bin\openvpn.exe" enable=yes protocol=UDP edge=deferuser
netsh advfirewall firewall add rule name="TUC OpenVPN TCP" dir=in action=allow program="%ProgramFiles%\openvpn\bin\openvpn.exe" enable=yes protocol=TCP edge=deferuser
REM   Altes VPN Profil lschen
IF EXIST "%ProgramFiles%\OpenVPN\config\TUC_OpenVPN.ovpn" DEL /F "%ProgramFiles%\OpenVPN\config\TUC_OpenVPN.ovpn"
REM   OpenVPN Dienst starten
start /wait net start OpenVPNServiceInteractive
REM OpenVPN GUI starten
start "" "%ProgramFiles%\OpenVPN\bin\openvpn-gui.exe"
@echo off
cls
echo.  
echo ===========================================
echo *                                         *
echo *    VPN wurde erfolgreich installiert    *
echo *                                         *
echo ===========================================
goto ende
exit

:keinadmin
cls
echo.  
echo           Fehler beim Ausfuehren
echo ============================================
echo *                                          *
echo *    Bitte starten Sie die Installation    *
echo *          als Administrator!!!            *
echo *                                          *
echo ============================================
goto ende
exit

:ende
Pause
exit